<template>
    <b-row>
        <b-col cols="12">
            <h2>
                User List
                <b-link href="#/">(User List)</b-link>
            </h2>
            <b-jumbotron>
                <template slot="header">{{user.team}}</template>
                <template slot="lead">
                    call sign: {{user.call_sign}}
                    <br>
                    spec: {{user.spec}}
                    <br>
                    pay grade: {{user.pay_grade}}
                    <br>
                    status: {{user.status}}
                    <br>
                    issue: {{user.issue}}
                    <br>
                    expire: {{user.expire}}
                    <br>
                    rank_id: {{user.rank_id}}
                    <br>
                    card_id: {{user.card_id}}
                    <br>
                    card_code: {{user.card_code}}
                </template>
                <hr class="my-4">
                <b-btn class="edit-btn" variant="success" @click.stop="editUser(user.id)">Edit</b-btn>
                <b-btn variant="danger" @click.stop="deleteUser(user.id)">Delete</b-btn>
            </b-jumbotron>
        </b-col>
    </b-row>
</template>

<script>
  import gql from "graphql-tag";
  import router from "../router";

  const GET_USER = gql`
  query user($userId: Int) {
    user(id: $userId) {
      id
      team
      call_sign
      spec
      pay_grade
      status
      issue
      expire
      rank_id
      card_id
      card_code
    }
  }
`;

  const DELETE_USER = gql`
  mutation removeUser($id: Int!) {
    removeUser(id: $id) {
      id
    }
  }
`;

  export default {
    name: "ShowUser",
    data() {
      return {
        user: '',
        userId: parseInt(this.$route.params.id)
      };
    },
    apollo: {
      user: {
        query: GET_USER,
        pollInterval: 300,
        variables() {
          return {
            userId: this.userId
          };
        }
      }
    },
    methods: {
      editUser(id) {
        router.push({
          name: "EditUser",
          params: { id: id }
        });
      },
      deleteUser(id) {
        this.$apollo
          .mutate({
            mutation: DELETE_USER,
            variables: {
              id: id
            }
          })
          .then(() => {
            // console.log(data);
            router.push({ name: "UserList" });
          })
          .catch(() => {
            // console.error(error);
          });
      }
    }
  };
</script>

<style>
    .jumbotron {
        padding: 2rem;
    }
    .edit-btn {
        margin-right: 20px;
        width: 70px;
    }
</style>